package events

type HostStartEvent struct {
	ZoneCount int
	Zone      int64
}

func (i HostStartEvent) GetUrl() string {
	return HOST_START
}

func NewHostStartEvent(zoneCount int, cidr int64) *DiscoveryStartEvent {
	return &HostStartEvent{ZoneCount: zoneCount, Zone: cidr}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

type HostFoundEvent struct {
	Zone int64
	Host int64
}

func (i HostFoundEvent) GetUrl() string {
	return HOST_FOUND
}

func NewHostFoundEvent(zone int64, host int64) *DiscoveryStartEvent {
	return &HostFoundEvent{Zone: zone, Host: host}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
type HostEndEvent struct {
	Zone int64
	Host int64
}

func (i HostEndEvent) GetUrl() string {
	return HOST_END
}

func NewHostEndEvent(zone int64, host int64) *DiscoveryStartEvent {
	return &HostEndEvent{Zone: zone, Host: host}
}
